<!DOCTYPE html>
<html
        lang="en"
        xmlns:th="http://www.thymeleaf.org"
        xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
        xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
        layout:decorate="~{layout3}"
>
<head>
    <meta charset="UTF-8" />
    <title>Department</title>
</head>
<body>

<main
        layout:fragment="main"
        class="container-xxl bd-gutter mt-3 my-md-4 bd-layout"
>
    <div th:include="sidebar/sidebar_masterdata::sidebar_masterdata" th:remove="tag">
        sidebar
    </div>


    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
                    <i class="fa fa-circle text-secondary" ></i> Department
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                <div class="alert alert-success mb-3" role="alert" th:if="${berhasil != null}">
                    <i class="fa fa-check"></i> <span th:text="${berhasil}"></span>
                </div>
                <div class="card shadow-sm border-0">
                    <div class="card-header p-4">
                        <div class="d-flex justify-content-between">
                            <span class="fw-bold text-secondary">List Of Department</span>
                            <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#departmentModal">
                                Add Department
                            </button>
                        </div>
                    </div>
                    <div class="card-body pt-4 pb-0 border-0">
                        <form method="get">
                            <div class="row">

                                <div class="col-md-9">
                                    Show entries <span sd:page-size-selector="javascript"></span>
                                </div>

                                <div class="col-md-3" align="right">
                                    <input
                                            class="form-control me-2"
                                            type="text"
                                            placeholder="Search"
                                            name="search"
                                            th:value="${search}"
                                            aria-label="Search"
                                    />
                                    <!--                <button class="btn btn-danger" type="submit" style="background-color: #15408d; border-color:#15408d">Log out</button>-->
                                </div>

                            </div>
                            <br />
                        </form>
                    </div>

                    <div class="card-body p-0 pb-0">
                        <div class="table-responsive mb-0">
                        <table class="table table-striped table-hover small mb-0">
                            <thead>
                            <tr>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0 text-end" scope="col" style="width: 10px">#</th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Company</th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Code</th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Name</th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Class</th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                                <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                            </tr>
                            </thead>
                            <tbody class="align-middle">
                            <tr th:each="dataDepartment,row : ${listDepartment}">
                                <td class="border-start-0 border-end-0 text-end" th:text="${(row.index + 1) + (listDepartment.number * listDepartment.size)+'.'}">1.</td>
                                <td class="border-start-0 border-end-0" >
                                    <span th:text="${dataDepartment.getCompanies().getCompanyName()}"></span>
                                </td>
                                <td class="border-start-0 border-end-0">
                                    <span th:text="${dataDepartment.getDepartmentCode()}"></span>
                                </td>
                                <td class="border-start-0 border-end-0">
                                    <span th:text="${dataDepartment.getDepartmentName()}"></span>
                                </td>
                                <td class="border-start-0 border-end-0">
                                    <div class="badge text-bg-success" th:if="${dataDepartment.getDepartmentClass().getJenis().toString().equals('FAKULTAS')}"  th:text="${dataDepartment.getDepartmentClass().getClassName()}"></div>
                                    <div class="badge text-bg-warning" th:if="${dataDepartment.getDepartmentClass().getJenis().toString().equals('PRODI')}"  th:text="${dataDepartment.getDepartmentClass().getClassName()}"></div>
                                    <div class="badge text-bg-secondary" th:if="${dataDepartment.getDepartmentClass().getJenis().toString().equals('TENDIK')}"  th:text="${dataDepartment.getDepartmentClass().getClassName()}"></div>
                                </td>
                                <td class="border-start-0 border-end-0">
<!--                                    <a class="btn btn-primary btn-sm" th:href="@{/masterdata/department/edit(department = ${dataDepartment.id},search = ${search}, page = ${page.getPageNumber()}, size = ${page.getPageSize()})}" title="Edit">-->
<!--                                        <i class="fa fa-gear"></i>-->
<!--                                    </a>-->
                                    <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal"
                                            data-bs-target="#departmentModal" th:data-id="${dataDepartment.getId()}" onclick="loadDepartmentData(this)">
                                        <i class="fa fa-edit"></i>
                                    </button>
                                </td>
                                <td class="border-start-0 border-end-0">
                                    <form method="post" th:action="@{/masterdata/department/delete(department=${dataDepartment.id},search = ${search}, page = ${page.getPageNumber()}, size = ${page.getPageSize()})}">
                                        <button type="submit" class="btn btn-danger btn-sm"
                                                onclick="return confirm('Are you sure want to delete this?')">
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </form>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        </div>
                    </div>

                    <div class="card-footer text-end p-4 bg-body border-top-0">
                        <nav aria-label="Page navigation example">
                            <ul class="pagination" sd:pagination="full"></ul>
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="departmentModal" tabindex="-1" aria-labelledby="departmentModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-header bg-primary text-light">
                        <h5 class="modal-title" id="departmentModalLabel"><i class="fa fa-edit text-secondary"></i> Form department</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <form class="form-horizontal" th:action="@{/masterdata/department/save}" th:object="${department}" method="post" enctype="multipart/form-data">
                        <div class="modal-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="companies" class="form-label text-secondary">Company</label>
                                        <select class="form-select" id="companies" aria-label="Default select example" th:field="*{companies}">
                                            <option th:each="data : ${listCompanies}"
                                                    th:text="${data.getCompanyName()}"
                                                    th:value="${data.getId()}">sdasd</option>
                                        </select>
                                        <div th:if="${#fields.hasErrors('companies')}" class="error-message" th:errors="*{companies}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="departmentCode" class="form-label text-secondary">Code</label>
                                        <input type="text" class="form-control" id="departmentCode" th:field="*{departmentCode}">
                                        <div th:if="${#fields.hasErrors('departmentCode')}" class="error-message" th:errors="*{departmentCode}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="departmentName" class="form-label text-secondary">Code</label>
                                        <input type="text" class="form-control" id="departmentName" th:field="*{departmentName}">
                                        <div th:if="${#fields.hasErrors('departmentName')}" class="error-message" th:errors="*{departmentName}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="departmentClass" class="form-label text-secondary">Clasification</label>
                                        <select class="form-select" id="departmentClass" aria-label="Default select example" th:field="*{departmentClass}">
                                            <option th:each="data : ${departmentClass}"
                                                    th:text="${data.getClassName()}"
                                                    th:value="${data.getId()}">sdasd</option>
                                        </select>
                                        <div th:if="${#fields.hasErrors('departmentClass')}" class="error-message" th:errors="*{departmentClass}" style="color: red;"></div>
                                    </div>
                                    <input type="hidden" name="search" th:value="${search}">
                                    <input class="form-control" type="hidden" name="id" id="idDept" th:field="*{id}">
                                    <input type="hidden" name="page" th:value="${page.getPageNumber()}">
                                    <input type="hidden" name="size" th:value="${page.getPageSize()}">
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer p-3">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                            <button type="submit" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </main>
</main>
</body>
</html>

<script>
    $('#departmentModal').on('shown.bs.modal', function () {
        // Inisialisasi Select2 untuk 'fakultas' setelah modal ditampilkan

        // Inisialisasi Select2 untuk 'department' setelah modal ditampilkan
        $('#companies').select2({
            theme: "bootstrap-5",
            width: '100%',  // Set width to 100% explicitly
            placeholder: 'Pilih Department',  // Tambahkan placeholder
            dropdownParent: $('#departmentModal')  // Pastikan dropdown berada di dalam modal
        });
    });
</script>

<script>
    $(document).ready(function() {
        var hasErrors = $('.error-message').length > 0; // Memeriksa jika ada elemen dengan kelas error-message
        console.log("Has Errors:", hasErrors); // Menampilkan apakah ada error
        if (hasErrors) {
            console.log("Showing modal"); // Menampilkan pesan di console
                $('#departmentModal').modal('show');
        }
    });
</script>
<script>

    // Load KPI data ke modal saat ingin mengedit
    function loadDepartmentData(button) {
        const id = $(button).data('id');
        $.ajax({
            url: '/masterdata/department/data/' + id,
            method: 'GET',
            success: function(response) {
                // Mengisi data ke dalam textarea dan input yang sesuai
                $('#departmentModal #companies').val(response.companies.id);
                $('#departmentModal #departmentCode').val(response.departmentCode);
                $('#departmentModal #departmentName').val(response.departmentName);
                $('#departmentModal #departmentClass').val(response.departmentClass.id);
                $('#departmentModal #idDept').val(response.id);
                $('#departmentModal').modal('show');  // Menampilkan modal setelah data diambil
            },
            error: function(error) {
                console.error("Error fetching Department data:", error);
            }
        });
    }

    $('#departmentModal').on('hidden.bs.modal', function() {
        // $(this).find('textarea, input, select').val(''); // Clear all textareas, inputs, and selects
        $(this).find('.form-control').val('');
        $(this).find('.form-select').val('');
        $('.error-message').empty();
    });


</script>





